#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "timer.h"
#include "log.h"

#ifdef _WIN32
#include <io.h>
#include <fcntl.h>
#endif

static void print_help(void)
{
   linelet_log_printf(LINELET_LOG_INFO, "linelet <program> args...\n\tAvailable programs: test psnr psnr_video ssim_video encode decode interleave gray rtp_send rtp_recv\n");
}

int test_main(int argc, char *argv[]);
int psnr_main(int argc, char *argv[]);
int encode_main(int argc, char *argv[]);
int decode_main(int argc, char *argv[]);
int psnr_video_main(int argc, char *argv[]);
int ssim_video_main(int argc, char *argv[]);
int interleave_main(int argc, char *argv[]);
int deinterleave_main(int argc, char *argv[]);
int gray_main(int argc, char *argv[]);
int rtp_send_main(int argc, char *argv[]);
int rtp_recv_main(int argc, char *argv[]);

int main(int argc, char *argv[])
{
#ifdef _WIN32
   _setmode(0, _O_BINARY);
   _setmode(1, _O_BINARY);
#endif

   if (argc < 2)
   {
      print_help();
      return EXIT_FAILURE;
   }

   argc--;
   argv++;

   int ret;
   if (!strcmp(argv[0], "test"))
      ret = test_main(argc, argv);
   else if (!strcmp(argv[0], "psnr"))
      ret = psnr_main(argc, argv);
   else if (!strcmp(argv[0], "psnr_video"))
      ret = psnr_video_main(argc, argv);
   else if (!strcmp(argv[0], "ssim_video"))
      ret = ssim_video_main(argc, argv);
   else if (!strcmp(argv[0], "encode"))
      ret = encode_main(argc, argv);
   else if (!strcmp(argv[0], "decode"))
      ret = decode_main(argc, argv);
   else if (!strcmp(argv[0], "interleave"))
      ret = interleave_main(argc, argv);
   else if (!strcmp(argv[0], "deinterleave"))
      ret = deinterleave_main(argc, argv);
   else if (!strcmp(argv[0], "gray"))
      ret = gray_main(argc, argv);
   else if (!strcmp(argv[0], "rtp_send"))
      return rtp_send_main(argc, argv);
   else if (!strcmp(argv[0], "rtp_recv"))
      return rtp_recv_main(argc, argv);
   else
   {
      print_help();
      return EXIT_FAILURE;
   }

   linelet_timer_log();
   return ret;
}

