#include "image.h"
#include "log.h"
#include <stdio.h>
#include <stdlib.h>

int psnr_main(int argc, char *argv[])
{
   int ret = 0;
   struct linelet_rgb_image a = {0}, b = {0};

   if (argc != 3)
   {
      linelet_log_printf(LINELET_LOG_INFO, "psnr <image a> <image b>\n");
      return EXIT_FAILURE;
   }

   if (!linelet_rgb_image_load(argv[1], &a))
   {
      linelet_log_printf(LINELET_LOG_INFO, "Failed to load image %s.\n", argv[1]);
      ret = EXIT_FAILURE;
      goto end;
   }

   if (!linelet_rgb_image_load(argv[2], &b))
   {
      linelet_log_printf(LINELET_LOG_INFO, "Failed to load image %s.\n", argv[2]);
      ret = EXIT_FAILURE;
      goto end;
   }

   struct linelet_rgb_psnr psnr;
   if (linelet_rgb_image_psnr(&psnr, &a, &b, a.bits))
      printf("PSNR (dB) || R: %.1f, G: %.1f, B: %.1f\n", psnr.r, psnr.g, psnr.b);
   else
      ret = EXIT_FAILURE;

end:
   linelet_rgb_image_free(&a);
   linelet_rgb_image_free(&b);
   return ret;
}
