#ifndef PACK_H__
#define PACK_H__

#include <stddef.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

size_t linelet_pack_nibbles_u8(uint8_t *output, const uint8_t *input, unsigned samples);
size_t linelet_unpack_nibbles_u8(uint8_t *output, const uint8_t *input, unsigned samples);

size_t linelet_pack_bits_s16(uint8_t *output, const int16_t *input, unsigned samples, unsigned blocks, const uint8_t *bits);
size_t linelet_unpack_bits_s16(int16_t *output, const uint8_t *input, unsigned samples, unsigned blocks, const uint8_t *bits);

size_t linelet_pack_predictive_unary(uint8_t *output, const uint8_t *input, unsigned samples);
size_t linelet_unpack_predictive_unary(uint8_t *output, const uint8_t *input, unsigned samples);

#ifdef __cplusplus
}
#endif
#endif

