#include "memory.h"
#include <stdint.h>
#include <stdlib.h>

#define MALLOC_ALIGN 64
void *linelet_malloc(size_t size)
{
   void *ptr = malloc(MALLOC_ALIGN + size + sizeof(uintptr_t));
   if (!ptr)
      return NULL;

   uintptr_t addr = ((uintptr_t)ptr + sizeof(uintptr_t) + MALLOC_ALIGN) & ~(MALLOC_ALIGN - 1);
   void **place   = (void**)addr;
   place[-1]      = ptr;

   return (void*)addr;
}

void *linelet_calloc(size_t elem_size, size_t size)
{
   size *= elem_size;

   void *ptr = calloc(1, MALLOC_ALIGN + size + sizeof(uintptr_t));
   if (!ptr)
      return NULL;

   uintptr_t addr = ((uintptr_t)ptr + sizeof(uintptr_t) + MALLOC_ALIGN) & ~(MALLOC_ALIGN - 1);
   void **place   = (void**)addr;
   place[-1]      = ptr;

   return (void*)addr;
}

void linelet_free(void *ptr)
{
   if (ptr)
   {
      void **p = (void**)ptr;
      free(p[-1]);
   }
}

