#!/usr/bin/env python

import sys
import os
import subprocess

def create_test(f, rates):
    base = os.path.splitext(f)[0].split('_lossless')[0]

    for rate in rates:
        target = base + '_' + str(rate)[:-3] + '.llv'
        print('Encoding lossy at ', str(rate)[:-3], 'Mbit/s to:', target)
        subprocess.check_call(['ffmpeg', '-y', '-i', f, '-c:v', 'liblinelet', '-b:v', str(rate) + 'k', '-slice_height', '16', '-precinct_samples', '64', '-slice_filter', '3', target])

def list_to_int(buf):
    ret = []
    for rate in buf:
        ret.append(int(rate) * 1000)
    return ret

if __name__ == '__main__':
    bitrates = sys.argv[1].split(',')
    for f in sys.argv[2:]:
        create_test(f, list_to_int(bitrates))
