#!/usr/bin/env python

import sys
import os
import subprocess

def encode(clip, tune):
    target = os.path.splitext(clip)[0] + '.mkv'
    print(tune + ':', clip, '->', target)
    subprocess.check_call(['x264', clip, '--fps', '24000/1001', '-B', '100000', '--keyint', '1', '--no-cabac', '--vbv-bufsize', '4000', '--nal-hrd', 'cbr', '--vbv-maxrate', '100000', '--preset', 'fast', '--output-csp', 'i422', '--tune', tune, '-o', target])

def test_encode(raw, test, prog):
    target = os.path.splitext(test)[0] + '.mkv'
    print(prog + ':', raw, '->', target)
    ffmpeg = subprocess.Popen(['ffmpeg', '-i', target, '-f', 'rawvideo', '-'], stdout = subprocess.PIPE)
    psnr = subprocess.Popen(['linelet', prog, raw, '-', '--size', '2048x857', '--pix_fmt', 'yuv422p10', '--total'], stdin = ffmpeg.stdout)
    psnr.communicate()

def test_clip(raw, reference, tests):
    encode(reference, 'psnr')
    for test in tests:
        encode(test, 'psnr')

    test_encode(raw, reference, 'psnr_video')
    for test in tests:
        test_encode(raw, test, 'psnr_video')

    encode(reference, 'ssim')
    for test in tests:
        encode(test, 'ssim')

    test_encode(raw, reference, 'ssim_video')
    for test in tests:
        test_encode(raw, test, 'ssim_video')

if __name__ == '__main__':
    test_clip(sys.argv[1], sys.argv[2], sys.argv[3:])

